import React, { ReactElement, useState } from 'react'
import {Row, Col, Input, Label, FormGroup} from "reactstrap"
import {FormSubmit} from "reactstrap-react-lib"

interface FORM{  name : string;  age : number;  firstName : string;  lastName : string;  mobile : string;}

interface Props{
    uri:string;
    inputsElements: FORM
}

export default function Patient(props: Props): ReactElement {
    let initialState:FORM
    if(props.inputsElements === undefined){
        initialState= {  
    name : undefined,  
    age : undefined,  
    firstName : undefined,  
    lastName : undefined,  
    mobile : undefined,}
    }else{
        initialState = props.inputsElements;
    }

    const [inputObj, setInputObj] = useState(initialState)
    return (
        <>
            <FormSubmit
                Inputs = {
                    
      <>
        <Row> 
          
    <Col sm={12} md={6} lg={3}>
      <FormGroup>
          <Label>name</Label>
          <Input type="text" 
          value={inputObj.name} 
          onChange={(e)=>setInputObj({...inputObj, name :e.target.value })}
 
      />
      </FormGroup>
    </Col>
    
    <Col sm={12} md={6} lg={3}>
      <FormGroup>
          <Label>age</Label>
          <Input type="number" 
          value={inputObj.age} 
          onChange={(e)=>setInputObj({...inputObj, age :parseInt(e.target.value) })}
 
      />
      </FormGroup>
    </Col>
    
    <Col sm={12} md={6} lg={3}>
      <FormGroup>
          <Label>firstName</Label>
          <Input type="text" 
          value={inputObj.firstName} 
          onChange={(e)=>setInputObj({...inputObj, firstName :e.target.value })}
 
      />
      </FormGroup>
    </Col>
    
    <Col sm={12} md={6} lg={3}>
      <FormGroup>
          <Label>lastName</Label>
          <Input type="text" 
          value={inputObj.lastName} 
          onChange={(e)=>setInputObj({...inputObj, lastName :e.target.value })}
 
      />
      </FormGroup>
    </Col>
    
    <Col sm={12} md={6} lg={3}>
      <FormGroup>
          <Label>mobile</Label>
          <Input type="text" 
          value={inputObj.mobile} 
          onChange={(e)=>setInputObj({...inputObj, mobile :e.target.value })}
 
      />
      </FormGroup>
    </Col>
    
        </Row>
      </>
                }
                curUri = {props.uri}
                curObj = {["POST", inputObj]}
                onSuccess = {(res)=>res.data?.mes  === undefined ? "success" : res.data.mes}
                onError = {(err)=> err.response?.data === undefined ? "error" : err.response.data }
                reset = {()=> setInputObj(initialState)}
                validation = {()=>""}
 
            />
        </>

    )
}